pipeline {
  agent { node { label 'latest' } }
  options {
    buildDiscarder logRotator(artifactDaysToKeepStr: '', artifactNumToKeepStr: '', daysToKeepStr: '', numToKeepStr: '10')
    ansiColor('xterm')
  }
  parameters {
    string defaultValue: 'master', description: '', name: 'Branch', trim: true
    string defaultValue: '1.4.4', description: '', name: 'PackerVersion', trim: true
    choice choices: ['us-east-1', 'us-east-1,eu-west-1'], description: '', name: 'DeployRegions'
  }
  stages {
    stage('Berks') {
      steps {
        withCredentials([sshUserPrivateKey(credentialsId: 'git', keyFileVariable: 'GIT_SSH_KEY', passphraseVariable: '', usernameVariable: 'GIT_USER')]) {
          script {
            currentBuild.displayName = "$Branch"
            wrap([$class: 'BuildUser']) {
              sh '''bash -x run.sh -s berks'''
            }
          }
        }
      }
    }
    stage('Build') {
      parallel {
        stage('Docker') {
          steps {
            script {
              wrap([$class: 'BuildUser']) {
                sh '''bash -x run.sh -s docker'''
              }
            }
          }
        }
        stage('EC2') {
          steps {
            script {
              wrap([$class: 'BuildUser']) {
                sh '''bash -x run.sh -s ec2'''
              }
              archiveArtifacts allowEmptyArchive: true, artifacts: 'amis.txt'
            }
          }
        }
      }
    }
  }
}
